//+------------------------------------------------------------------------------------------------------------------+
//|                                                                          ZI_FileFunctionsFullIntengerData.lib.mq4|
//|                                                                          Copyright  Zhunko & Ilnur              |
//|                                                                          ZHUNKO vadim@zhunko.ru                  |
//|24.10.2008 - 20.10.2009                                                   Ilnur  X-79@yandex.ru                   |
//+------------------------------------------------------------------------------------------------------------------+
//|                                     .                                |
//+------------------------------------------------------------------------------------------------------------------+
//| 1.  "     ".                                                  |
//| 2.  "      ".                                          |
//| 3.       .                                                               |
//| 4.         .                                                |
//| 5.         .                                           |
//| 6.            .                |
//| 7.       .                                                  |
//+------------------------------------------------------------------------------------------------------------------+
#property copyright "Copyright  2008 Zhunko, Ilnur"
#property link      "vadim@zhunko.ru ; X-79@yandex.ru"
#property library
//  .
#import "kernel32.dll"
 bool ReadFile (int hFile, int& lpBuffer[], int nNumberOfBytesToRead, int& lpNumberOfBytesRead[], int lpOverlapped);
 bool WriteFile (int hFile, int lpBuffer[], int nNumberOfBytesToWrite, int& lpNumberOfBytesWritten[], int lpOverlapped);
 void RtlMoveMemory (int& Destination[], int Source[], int Length);
#import "ntdll.dll"
 int  RtlGetLastWin32Error();
 int  RtlSetLastWin32Error (int dwErrCode);
#import
#include <WinKernel32.mqh> //    "kernel32.dll"  API Windows XP.
//=================================================================================================================================================================================
// 1.  "     ".
//      p     .    p   "-1".
//      .
int FileOperationsIntValue (string PathName,       //  .
                            int&   Value,          //     .
                            int    Size,           //  : CHAR_VALUE  (1 );
                                                   //               SHORT_VALUE (2 );
                                                   //               LONG_VALUE  (4 ).
                            int    ModeCWR,        //     : 0 - FILE_FULL_CREATE     ;
                                                   //                                     1 - FILE_FULL_WRITE    ;
                                                   //                                     2 - FILE_FULL_READ     .
                            int    Offset,         //     .
                            int    Origin,         //    : SEEK_CUR -   ,
                                                   //                                          SEEK_SET -  ,
                                                   //                                          SEEK_END -   ).
                            int&   ArOutputByte[]) //     .
 {
  int Error;  //   .
  int Handle; //   .
  //----
  int ArBuffer[1] = {0}; //     .
  //----
  ArrayResize (ArOutputByte, 1);
  //----
  RtlSetLastWin32Error (0); //  .
  switch (ModeCWR)
   {
    case 0: Handle = CreateFileA (PathName, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); break; //  .
    case 1: Handle = CreateFileA (PathName, GENERIC_WRITE|GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); break; //  .
    case 2: Handle = CreateFileA (PathName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); break;   //  .
    default: Print ("   \"FileOperationsIntValue()\".        \"", PathName, "\"   . ModeCWR = ", ModeCWR); return (-1);
   }
  if (Handle == -1) //    .
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileOperationsIntValue()\".    \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
    return (-1);
   }
  if (SetFilePointer (Handle, Offset, NULL, Origin) == -1) //   ,   ,  .
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileOperationsIntValue()\".      \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
    RtlSetLastWin32Error (0); //  .
    if (CloseHandle (Handle) == false)
     {
      Error = RtlGetLastWin32Error();
      Print ("   \"FileOperationsIntValue()\".    \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
     }
    return (-1);
   }
  switch (ModeCWR)
   {
    case 0: //       .
    case 1: //       .
     {
      ArBuffer[0] = Value;
      if (WriteFile (Handle, ArBuffer, Size, ArOutputByte, NULL) == false)
       {
        Error = RtlGetLastWin32Error();
        Print ("   \"FileOperationsIntValue()\".      \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
       }
      break;
     }
    case 2: //    .
     {
      if (ReadFile (Handle, ArBuffer, Size, ArOutputByte, NULL) == false)
       {
        Error = RtlGetLastWin32Error();
        Print ("   \"FileOperationsIntValue()\".      \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
       }
      else Value = ArBuffer[0];
      break;
     }
   }
  if (CloseHandle (Handle) == false) //  .
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileOperationsIntValue()\".    \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
    return (-1);
   }
  switch (ModeCWR)
   {
    case 0: return (ArOutputByte[0]); //    .
    case 1: return (ArOutputByte[0]); //    .
    case 2: return (ArBuffer[0]);     //   .
   }
 }
//=================================================================================================================================================================================
// 2.  "      ".
// p     .    p   "-1".
int FileOperationsIntArray (string PathName, //  .
                            int&   Array[],  //     .
                            int    ModeCWR,  //     : 0 - FILE_FULL_CREATE     ;
                                             //                                     1 - FILE_FULL_WRITE    ;
                                             //                                     2 - FILE_FULL_READ     .
                            int    Start,    //          .
                            int    Count,    //          .
                            int    Offset,   //     .
                            int    Origin)   //    : SEEK_CUR -   ,
                                             //                                          SEEK_SET -  ,
                                             //                                          SEEK_END -   ).
 {
  int Bytes = 4 * Count;  //   .
  int Error;              //   .
  int Handle;             //   .
  int Size;               //  .
  //----
  int ArOutputByte[1];    //        .
  int ArTemp1[];          //  .
  int ArTemp2[];          //  .
  //----
  RtlSetLastWin32Error (0); //  .
  switch (ModeCWR)
   {
    case 0: Handle = CreateFileA (PathName, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); break; //  .
    case 1: Handle = CreateFileA (PathName, GENERIC_WRITE|GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); break; //  .
    case 2: Handle = CreateFileA (PathName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); break;   //  .
    default: Print ("   \"FileOperationsIntArray()\".        \"", PathName, "\"   . ModeCWR = ", ModeCWR); return (-1);
   }
  if (Handle == -1) //    .
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileOperationsIntArray()\".    \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
    return (-1);
   }
  if (SetFilePointer (Handle, Offset, NULL, Origin) == -1) //   ,   ,  .
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileOperationsIntArray()\".      \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
    RtlSetLastWin32Error (0); //  .
    if (CloseHandle (Handle) == false)
     {
      Error = RtlGetLastWin32Error();
      Print ("   \"FileOperationsIntArray()\".    \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
     }
    return (-1);
   }
  switch (ModeCWR)
   {
    case 0: //       .
    case 1: //       .
     {
      Size = ArraySize (Array);             //   .
      ArrayResize (ArTemp1, Size);          //        .
      RtlMoveMemory (ArTemp1, Array, Size); //        .
      if (Start != 0) ArrayCopy (ArTemp1, ArTemp1, 0, Start, Count);       //      .
      if (WriteFile (Handle, ArTemp1, Bytes, ArOutputByte, NULL) == false) //      .
       {
        Error = RtlGetLastWin32Error();
        Print ("   \"FileOperationsIntArray()\".      \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
       }
      break;
     }
    case 2: //    .
     {
      ArrayResize (ArTemp1, Count); //        .
      if (ReadFile (Handle, ArTemp1, Bytes, ArOutputByte, NULL) == false) //        .
       {
        Error = RtlGetLastWin32Error();
        Print ("   \"FileOperationsIntArray()\".      \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
       }
      Size = ArraySize (Array);                             //   .
      if (Size < (Start + Count)) Count = Size - Start;     //          .
      if (Start == 0) RtlMoveMemory (Array, ArTemp1, Size); //     ,          .
      else                                                  //      .
       {
        ArrayResize (ArTemp2, Size);                        //         .
        RtlMoveMemory (ArTemp2, Array, Size);               //         .    .
        ArrayCopy (ArTemp2, ArTemp1, Start, 0, Count);      //          (  ).
        RtlMoveMemory (Array, ArTemp2, Size);               //         .
        ArrayResize (ArTemp2, 0);                           //    .
       }
      break;
     }
   }
  if (CloseHandle (Handle) == false) //  .
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileOperationsIntArray()\".    \"", PathName, "\"  .  : \"", Error, "\". ", StringError (Error));
    return (-1);
   }
  ArrayResize (ArTemp1, 0); //  .
  return (ArOutputByte[0] / 4);
 }
//=================================================================================================================================================================================
// 3.       .
//           .
int FileWriteIntegerFull (int Handle, //  ,   "FileOpenFull()".
                          int Value,  //  .
                          int Size)   //  : CHAR_VALUE  (1 );
                                      //               SHORT_VALUE (2 );
                                      //               LONG_VALUE  (4 ).
 {
  int Error;             //   .
  //----
  int ArBuffer[1] = {0}; //     .
  int ArOutputByte[1];   //     .
  //----
  RtlSetLastWin32Error (0); //  .
  ArBuffer[0] = Value;
  if (WriteFile (Handle, ArBuffer, Size, ArOutputByte, NULL) == false)
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileWriteIntegerFull()\".     .  : \"", Error, "\". ", StringError (Error));
    return (-1);
   }
  else return (ArOutputByte[0]);
 }
//=================================================================================================================================================================================
// 4.         .
int FileReadIntegerFull (int Handle, //  ,   "FileOpenFull()".
                         int Size)   //  : CHAR_VALUE  (1 );
                                     //               SHORT_VALUE (2 );
                                     //               LONG_VALUE  (4 ).
 {
  int Error;                //   .
  //----
  int ArBuffer[1] = {0}; //     .
  int ArOutputByte[1];   //     .
  //----
  RtlSetLastWin32Error (0); //  .
  if (ReadFile (Handle, ArBuffer, Size, ArOutputByte, NULL) == false)
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileReadIntegerFull()\".     .  : \"", Error, "\". ", StringError (Error));
    return (0);
   }
  else return (ArBuffer[0]);
 }
//=================================================================================================================================================================================
// 5.         .
//            .
int FileWriteIntegerArrayFull (int Handle,  //  ,   "FileOpenFull()".
                               int Array[], //  .
                               int Start,   //      .
                               int Count)   //        .
 {
  int  Error;          //   .
  int  Size;           //  .
  // .
  int ArOutputByte[1]; //     .
  int ArTemp1[];       //  .
  //----
  RtlSetLastWin32Error (0); //  .
  Size = ArraySize (Array);             //   .
  ArrayResize (ArTemp1, Size);          //        .
  RtlMoveMemory (ArTemp1, Array, Size); //        .
  if (Start != 0) ArrayCopy (ArTemp1, ArTemp1, 0, Start, Count);           //      .
  if (WriteFile (Handle, ArTemp1, 4 * Count, ArOutputByte, NULL) == false) //      .
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileWriteIntegerArrayFull()\".       \"", Handle, "\"  .  : \"", Error, "\". ", StringError (Error));
    return (-1);
   }
  else return (ArOutputByte[0] / 4); //    .
 }
//=================================================================================================================================================================================
// 6.            .
int FileReadIntegerArrayFull (int  Handle,  //  ,   "FileOpenFull()".
                              int& Array[], //  .
                              int  Start,   //          .
                              int  Count)   //          .
 {
  int Error;           //   .
  int Size;            //  .
  //----
  int ArOutputByte[1]; //     .
  int ArTemp1[];       //  .
  int ArTemp2[];       //  .
  //----
  ArrayResize (ArTemp1, Count); //        .
  if (ReadFile (Handle, ArTemp1, 4 * Count, ArOutputByte, NULL) == false) //        .
   {
    Error = RtlGetLastWin32Error();
    Print ("   \"FileReadIntegerArrayFull()\".       \"", Handle, "\"  .  : \"", Error, "\". ", StringError (Error));
    return (-1);
   }
  Size = ArraySize (Array);                             //   .
  if (Size < (Start + Count)) Count = Size - Start;     //          .
  if (Start == 0) RtlMoveMemory (Array, ArTemp1, Size); //     ,          .
  else                                                  //      .
   {
    ArrayResize (ArTemp2, Size);                        //         .
    RtlMoveMemory (ArTemp2, Array, Size);               //         .    .
    ArrayCopy (ArTemp2, ArTemp1, Start, 0, Count);      //          (  ).
    RtlMoveMemory (Array, ArTemp2, Size);               //         .
    ArrayResize (ArTemp2, 0);                           //    .
   }
  return (ArOutputByte[0] / 4);                         //    .
 }
//=================================================================================================================================================================================
// 7.       .
string StringError (int ErrorCode)
 {
  int    i;
  string String = "";
  //----
  int    Buffer[128];
  //----
  ArrayInitialize (Buffer, 0);
  FormatMessageA (0x1000, 0, ErrorCode, 0, Buffer, ArraySize (Buffer), 0);
  //----
  for (i = 0; i < ArraySize (Buffer); i++)
   {
    String = String + CharToStr (Buffer[i]       & 0xFF)
                    + CharToStr (Buffer[i] >>  8 & 0xFF)
                    + CharToStr (Buffer[i] >> 16 & 0xFF)
                    + CharToStr (Buffer[i] >> 24 & 0xFF);
   }
  return (StringTrimRight (String));
 }
//